*** Settings ***
Library    OperatingSystem
Library    BuiltIn
Library    JSONLibrary
Library    Collections
Library    JSONSchemaLibrary    schemas/
Library    Process
Default Tags     USE_POLLING

Resource    GenericKeywords.robot
Resource    SOL003-Keywords.robot
Resource    SOL005-Keywords.robot


*** Test Cases ***
VNF scaling triggered through scale NS procedure
    Check Preconditions
    POST Scale a nsInstance
    GET LCM Operation Occurrency Id
    Check NSScale Status
    

*** Keywords ***
Check Preconditions
    [Tags]    PRECONDITION_CHECK
    Check VNFs Instances are in INSTANTIATED state
    Check NS Instance is in INSTANTIATED state


Check NS Instance is in INSTANTIATED state
    GET Information about an individual NS Instance
    Should Be Equal As Strings    ${response['body']['nsState']}    INSTANTIATED

    
Check VNFs Instances are in INSTANTIATED state
    GET Information about an individual NS Instance
    Set Suite Variable    @{vnfInstancesList}    ${response['vnfInstance']}
    ${length}    Get Length    ${vnfInstancesList}
    :FOR    ${i}    IN RANGE    0    ${length}    
    \    ${value}    Get From List    ${vnfInstancesList}    ${i}
    \    Set Suite Variable    ${vnfInstanceId}    ${value}
    \    GET individual vnfInstance
    \    Should Be Equal As Strings    ${response['body']['instantiationState']}    INSTANTIATED 


Check NSScale Status
    Wait Until Keyword Succeeds   20m    30s
    ...    Check VNFs Operation Status
    Wait Until Keyword Succeeds    5m    30s    
    ...    Check NsOpOccId State


Check NsOpOccId State
    GET Individual NS LCM OP Occurrence
    Should Be Equal As Strings    ${response['nsState']}    INSTANTIATED    


Check VNFs Operation Status
    GET information about multiple VNF instances
    Set Suite Variable    ${vnfInstances}    ${response['body']}    
    ##TODO: Filter VNF LCM OpOCC related to vnfInstanceId
    GET status information about multiple VNF LCM Operation OCC with "fields"
    Set Suite Variable     ${vnfLcmOpOccs}    ${response['body']}   
    Wait Until Keyword Succeeds    20m    30s    
    ...    Get affected VNFs


Get affected VNFs
    ${length}    Get Length    ${vnfLcmOpOccs}
    :FOR     ${i}     IN RANGE    0    ${length}   
    \    ${value}    Get From List    ${vnfLcmOpOccs}    ${i}
    \    Get information about VNF instances    ${value['id']}
    \    Should Be Equal As Strings    ${response['body']['operationState']}    COMPLETED