*** Settings ***
Library    OperatingSystem
Library    BuiltIn
Library    JSONLibrary
Library    Collections
Library    JSONSchemaLibrary    schemas/
Default Tags     USE_POLLING

Resource    GenericKeywords.robot
Resource    SOL003-Keywords.robot
Resource    SOL005-Keywords.robot



*** Test Cases ***
Terminate an NS Instance
    Check Preconditions
    POST Terminate a NSInstance
    GET LCM Operation Occurrency Id
    Check NSInstance Status    
    DELETE Individual NSInstance    


*** Keywords ***
Check Preconditions
    [Tags]    PRECONDITION_CHECK
    Check NS Instance is in INSTANTIATED state


Check NS Instance is in INSTANTIATED state
    GET Information about an individual NS Instance
    Should Be Equal As Strings    ${response['body']['nsState']}    INSTANTIATED



Check OperationState on update Request
    Get status information about Individual NS LCM occurrences
    Should Be Equal As Strings    ${response['body']['operationState']}    COMPLETED      



Check NSInstance Status
    GET information about multiple VNF instances
    Set Suite Variable    ${vnfInstances}    ${response['body']}    
    GET status information about multiple VNF LCM Operation OCC with "fields"
    Set Suite Variable    ${vnfLcmOpOccs}    ${response['body']}    
    Get status information about Individual NS LCM occurrences
    ${value}=  Run Keyword And Return Status    Should Not Be Equal As Strings  ${response['body']['operationState']}    COMPLETED
    Run Keyword If    ${value} == True    
    ...    Check NS and VNF Status 

Check NS and VNF Status
    Wait Until Keyword Succeeds    20m    30s    
    ...    Get affected VNFs
   
Get affected VNFs
    ${length}    Get Length    ${vnfLcmOpOccs}
    :FOR     ${i}     IN RANGE    0    ${length}
    \    ${value}    Get From List    ${vnfLcmOpOccs}    ${i}
    \    Get information about VNF instances    ${value['id']}
    \    Should Be Equal As Strings    ${response['body']['operationState']}    COMPLETED
    

