*** Settings ***
Library    OperatingSystem
Library    BuiltIn
Library    JSONLibrary
Library    Collections
Library    JSONSchemaLibrary    schemas/
Default Tags     USE_POLLING

Resource    GenericKeywords.robot
Resource    SOL003-Keywords.robot
Resource    SOL005-Keywords.robot




*** Test Cases ***
Terminate an NS Instance
    Check Preconditions
    Terminate constituents from NS Instance
    POST Terminate a NSInstance
    GET LCM Operation Occurrency Id
    DELETE Individual NSInstance    


*** Keywords ***
Check Preconditions
    [Tags]    PRECONDITION_CHECK
    Check NS Instance is in INSTANTIATED state


Check NS Instance is in INSTANTIATED state
    GET Information about an individual NS Instance
    Should Be Equal As Strings    ${response['body']['nsState']}    INSTANTIATED


Terminate constituents from NS Instance
    GET Information about an individual NS Instance
    Log    Remove constituent VNFs, if any
    @{instancesList}    Create List
    ${length}    Get Length    ${response['vnfInstance']}
    :FOR    ${i}     IN RANGE    0    ${length}    
    \    ${value}    Get From List    ${response['vnfInstance']}    ${i}
    \    Append To List    ${instancesList}    ${value['id']}
    Set Suite Variable    ${updateType}    REMOVE_VNF
    Set Suite Variable    ${instancesList}    ${instancesList}
    ${total}=    Get Length    ${instancesList}
    ${value}=    Run Keyword And Return Status    Should Not Be Equal As Numbers    ${total}    0
    Run Keyword If   ${value} == True
    ...    Remove constituent VNFs
    Log    Remove constituent PNFs, if any
    @{instancesList}    Create List
    ${length}    Get Length    ${response['pnfInfo']} 
    :FOR    ${i}    IN RANGE    0    ${length} 
    \    ${value}    Get From List    ${response['pnfInfo']}    ${i}
    \    Append To List    ${instancesList}    ${value['pnfId']}
    Set Suite Variable    ${updateType}    REMOVE_PNF
    Set Suite Variable    ${instancesList}    ${instancesList}
    ${total}=    Get Length    ${instancesList}
    ${value}    Run Keyword And Return Status    Should Not Be Equal As Numbers    ${total}    0    
    Run Keyword If    ${value} == True
    ...    Remove constituent PNFs


Remove constituent VNFs
    POST Update a NSInstance
    GET LCM Operation Occurrency Id
    Check VNFs Operation Status
    Get status information about Individual NS LCM occurrences
    Should Be Equal As Strings    ${response['body']['operationState']}    COMPLETED      

    
Check VNFs Operation Status
    GET information about multiple VNF instances
    Set Suite Variable    ${vnfInstances}    ${response['body']}   
    GET status information about multiple VNF LCM Operation OCC with "fields"
    Set Suite Variable    ${vnfLcmOpOccs}    ${response[body]}    
    Wait Until Keyword Succeeds    20m    30s    
    ...    Get affected VNFs


Get affected VNFs
    ${length}    Get Length    ${vnfLcmOpOccs}
    :FOR     ${i}     IN RANGE    0    ${length}   
    \    ${value}    Get From List     ${vnfLcmOpOccs}    ${i}
    \    Get information about VNF instances    ${value['id']}
    \    Should Be Equal As Strings    ${response['body']['operationState']}    COMPLETED 
    
Remove constituent PNFs
    POST Update a NSInstance
    GET LCM Operation Occurrency Id
    Wait Until Keyword Succeeds    20m    30s
    ...    Check OperationState on Update Request


Check OperationState on update Request
    Get status information about Individual NS LCM occurrences
    Should Be Equal As Strings    ${response['body']['operationState']}    COMPLETED      
    